> For the complete documentation index, see [llms.txt](https://docs.gentee.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.gentee.org/syntax/include-and-import.md).

# Include and import

### Include and import declarations

The **include** declaration imports all types, functions and constants from the specified files and their included files.

The **import** declaration imports only public types, functions and constants from the specified files and their included files. Public objects are defined using the **pub** keyword.

```
stringConst         = "`" { unicode_char } "`" | stringDoubleConst
stringDoubleConst = `"` { unicode_char | uShort | uLong | escapedChar | byteVal } `"`
importDecl = "import" "{" {stringConst newline} "}"
includeDecl = "include" "{" {stringConst newline} "}"
```

Consider the visibility of objects as a table. Let there be two files.

```
// a.g can include or import b.g
func afunc(i int) : return i*2
pub func apubfunc(i int) : return i*3

// b.g 
func bfunc(i int) : return i*4
pub func bpubfunc(i int) : return i*5
```

Let the *c.g* file can import or include *a.g* file. You can see what functions are visible in *c.g* in different situations.

|          | <p>include a <br> a includes b</p> | <p>include a <br> a imports b</p> | <p>import a <br> a includes b</p> | <p>import a <br> a imports b</p> |
| -------- | ---------------------------------- | --------------------------------- | --------------------------------- | -------------------------------- |
| afunc    | visible                            | visible                           |                                   |                                  |
| apubfunc | visible                            | visible                           | visible                           | visible                          |
| bfunc    | visible                            |                                   |                                   |                                  |
| bpubfunc | visible                            |                                   | visible                           |                                  |

### Pub declaration

The **pub** declaration marks the next function, type or constants as public. They can be imported with **import** declaration.

```
pubDecl = "pub"
objects = [pubDecl] (structDecl | FnDecl | ConstDecl | FunctionDecl)
```

The **pub** keyword indicates that the next function, constants, or structure will be passed when the file is imported.

```
pub const IOTA {  // public constants. Visible when include or import
    MY1
    MY2
}

const IOTA*2 {  // private constants. Visible only when include
    MY3
    MY4
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.gentee.org/syntax/include-and-import.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
